
; ATMega8

; *************** NICHT GETESTET *****************

; Version v0.1 24.07.2006 M'Soft Berlin

; Umgestellt auf 6 Pixel FONT_SIZE, Text sieht so besser aus.
; Ein paar Aufrmarbeiten dazu...

.include "m8def.inc"

; programmierte FUSE: SUT0 CKSEL3 CKSEL2 CKSEL1 CKSEL0 - ext. Clock - Slowly Rising Power 

; Definitionen

; Belegungen der Atmel-Ports:

;*****************************************************************

;	 PD0-PD7		LCD_D0 - LCD_D7

;    PB0        ICP1	  LCD_RE
;    PB1        OC1A	  LCD_CD
;    PB2        OC1B/SS	  LCD_CE
;    PB3        MOSI	  LCD_WR
;    PB4        MISO	  LCD_RD


;*****************************************************************

;--- Allgemeines -----------------------------------------------

.equ    F_CPU           = 8000000
.equ    CYCLES_PER_US   = ((F_CPU+500000)/1000000)

.equ	TXT_BASE		= $0000
.equ	GFX_BASE		= $0300

.equ	FONT_SIZE		= 6

.equ	SPALTEN			= 240/FONT_SIZE
.equ	GFX_ZEILEN		= 128
.equ	TXT_ZEILEN		= 128/8

;				0bxxxxxyyyyyyyyzzz
;	x - CHR_OFFSET
;   y - CHR_CODE
;   z = CHR_LINE

.equ	CHR_OFFSET		= 3
.equ	CHR_CODE		= $80					; erster Charakter
.equ	CHR_BASE		= (CHR_OFFSET<<11)+(CHR_CODE<<3)

.equ	CHR_ANZ			= 11				; Anzahl Zeichen, die definiert werden

;--- Flag-Werte --------------------------------------------------- 

;--- Display-Kommandos--------------------------------------------- 

.equ	TXTHOME			= $40				; Set Text Home Adresse
.equ	TXTAREA			= $41				; Set Text Area
.equ	GFXHOME			= $42				; Set Grafik Home Adresse
.equ	GFXAREA			= $43				; Set Grafik Area
.equ	OFFSETA			= $22				; Set Offset Adresse
.equ	ADPSET			= $24				; Set Adress-Zeiger
.equ	AWRON				= $B0				; Set Auto-Write ON
.equ	AWROFF			= $B2				; Set Auto-Write OFF
.equ	BITSET			= $F8				; Set Bit an Adresse
.equ	BITCLR			= $F0				; Clr Bit an Adresse
.equ 	WRITELCD		= $C4				; Schreibt Daten ohne Adresszeiger zu ndern		
.equ	WRITEINC		= $C0				; Schreibt Daten und erhht Adresszeiger um 1
.equ	WRITEDEC		= $C2				; Schreibt Daten und verringert Adresszeiger um 1

.equ	MODE			= 0b10000000		; Display an - Mode OR
.equ	MODE_EOR		= 0b00000001		; Display an - Mode EOR
.equ	MODE_AND		= 0b00000011		; Display an - Mode AND
.equ	MODE_ATTR		= 0b00000100		; Display an - Mode TEXT-ATTRIBUT
.equ	MODE_EXT_CG		= 0b00001000		; Display an - Mode EXTERNER CG

.equ	D_MODE			= 0b10010000		; Display-Mode
.equ	D_MODE_CUR		= 0b00000010		; Cursor an
.equ	D_MODE_CB		= 0b00000011		; Cursor und Blinken an

.equ	D_MODE_TXT		= 0b00000100		; Text an
.equ	D_MODE_GFX		= 0b00001000		; Grafik an
.equ	D_MODE_TXT_GFX	= 0b00001100		; Text und Grafik an

.equ	STAT_CMD		= 0
.equ	STAT_RW			= 1
.equ	STAT_R_AUTO		= 2
.equ	STAT_W_AUTO		= 3


;**************************** Ram-Reservierungen ******************

;--- Internes Ram -------------------------------------------------

.DSEG

.ORG    $0100    
TABELLE:	.byte	FONT_SIZE*SPALTEN		; Anzahl Grafik-Spalten

; $0180-$025F Stack                         ; 224 Byte...

;**************************** Register-Bits **************************
;--- Display ----------------------------------------------------------

.equ	LCD_C_PORT  = PORTB
.equ	LCD_RE		= PB0					; Reset		L
.equ	LCD_CD		= PB1					; Code/Data H/L
.equ	LCD_CE		= PB2					; Enable	L
.equ	LCD_WR		= PB3					; Write		L
.equ	LCD_RD		= PB4					; Read		L

.equ	LCD_D_OUT   = PORTD
.equ	LCD_D_IN    = PIND
.equ	LCD_D_DIR   = DDRD

;--- lower Register -----------------------------------------------

;--- higher Register ----------------------------------------------

.def    TEMP_A      = r16                   ; temporres  8Bit-Register
.def    TEMP_B      = r17                   ; temporres  8Bit-Register

; r26/r27, r28/r29, r30/r31 fr X,Y,Z reserviert 

;--- Macros -------------------------------------------------------

.macro  load_p                      ; ldt 16Bit @1 nach @0 High und @0 Low

        ldi     @0H,HIGH(@1)
        ldi     @0L,LOW(@1)

.endmacro

;****************************** Verktor-Liste ****************************

.CSEG
                rjmp    Reset
.org INT0addr
                reti
.org INT1addr
                reti
.org OC2addr
                reti
.org OVF2addr
                reti
.org ICP1addr
                reti
.org OC1Aaddr
                reti
.org OC1Baddr
                reti
.org OVF1addr
				reti
.org OVF0addr
                reti
.org URXCaddr
                reti
.org UDREaddr
                reti
.org UTXCaddr
                reti
.org ADCCaddr
                reti
.org ERDYaddr
				reti
.org ACIaddr
				reti
.org TWIaddr
				reti
.org SPMRaddr
				reti


;****************************** Programm-Beginn **********************

;*********************************************************************
;  Initialisierungsroutine
;*********************************************************************

; Hardware initialisieren

Reset:  ldi     TEMP_A,low(RAMEND)          ; Stack an das interne Ram-Ende
        out     SPL,TEMP_A
        ldi     TEMP_A,high(RAMEND)
        out     SPH,TEMP_A

; Port B *************************************************************

        ser     TEMP_A
        out     PORTB,TEMP_A                ; Alle PullUp ein bzw. Ausgang auf High
		ldi		TEMP_A,(1<<LCD_RD)+(1<<LCD_WR)+(1<<LCD_CE)+(1<<LCD_CD)+(1<<LCD_RE)			
        out     DDRB,TEMP_A

; Port C *************************************************************

        ser     TEMP_A
        out     PORTC,TEMP_A                ; Alle PullUp ein bzw. Ausgang auf High
		clr		TEMP_A						; Alles Eingang			
        out     DDRC,TEMP_A

; Port D *************************************************************

		ser		TEMP_A
        out     PORTD,TEMP_A                ; Alle PullUp ein bzw. Ausgang auf High
		ser		TEMP_A						; Alles Ausgang, Displaydaten				
        out     DDRD,TEMP_A
  
;*********************************************************************				 

/* 	Hier wird die Messwerttabelle im Ram erstellt, gibt ja noch keine echten Werte...
	Die Rumrechnerei dabei sorgt nur fr passendere Werte,
	die Sinustabelle lag irgendwo im Netz...
	Der angedachte Wertebereich wird wohl 0...99 werden,
	dann bleibt Platz fr Beschriftungen.
	Breite wei ich auch noch nicht, evtl. 224 Werte.
	Das ist alles noch sehr unklar. ;)
	X/Y-Markierungen usw. werden als Zeichensatz angelegt, damit kann dann die Grafik
	ohne Probleme gelscht und neu gezeichnet werden.
	Hor.Line und Vert. Line sind vor allem als Cursor gedacht.                       */

		load_p	Y,TABELLE					; Sinuswerte ins Ram zum Testen
		ldi		TEMP_B,(SPALTEN*FONT_SIZE)+1
		clr		TEMP_A

init_loop_0:
		load_p	Z,(2*sinus)

init_loop_1:		
		dec		TEMP_B
		breq	init_loop_end

		adiw	Z,1							; nur jeden 2. Wert	
		push	TEMP_A
		lpm		TEMP_A,Z+
		lsr		TEMP_A						; Wert / 2	 
		subi	TEMP_A,-31					; nach oben verschieben		
		st		Y+,TEMP_A
		pop		TEMP_A
		dec		TEMP_A						; nur jeden 2. Wert
		dec		TEMP_A
		brne	init_loop_1

		rjmp	init_loop_0

init_loop_end:

		rcall	lcd_init
			 
;*********************************************************************
;  Main-Loop
;*********************************************************************

main:

		ldi		YH,2						; Zeile
		ldi		YL,(SPALTEN-20)/2			; Spalte - 20: Textlnge...
		load_p	Z,(2*text_1)
		rcall	lcd_write_rom_txt

		ldi		YH,4						; Zeile
		ldi		YL,(SPALTEN-21)/2			; Spalte - 10: Textlnge...
		load_p	Z,(2*text_2)
		rcall	lcd_write_rom_txt

		ldi		TEMP_A,64					; Zeilennummer
		rcall	lcd_hor_line

		ldi		TEMP_A,119					; Spaltennummer
		rcall	lcd_vert_line
			
		rcall	lcd_write_table				; Wertetabelle aus Ram

main_end:
		rjmp	main_end

;*********************************************************************
;  Subroutinen Display
;*********************************************************************

;***************************************************************************
;  Initialisiert das Display
;
;  Scratch-Reg: TEMP_A, 
;***************************************************************************
lcd_init:
		cbi		LCD_C_PORT,LCD_RE		; Reset auf L
		rcall	wait_5ms
		sbi		LCD_C_PORT,LCD_RE		; Reset auf H
		rcall	wait_5ms

		ldi		TEMP_A,low(TXT_BASE)	; Text Start Adresse
		rcall	lcd_write_data			; Daten
		ldi		TEMP_A,high(TXT_BASE)
		rcall	lcd_write_data			; Daten
		ldi		TEMP_A,TXTHOME
		rcall	lcd_write_cmd			; Kommando

		ldi		TEMP_A,low(GFX_BASE)	; Grafik Start Adresse
		rcall	lcd_write_data			; Daten
		ldi		TEMP_A,high(GFX_BASE)
		rcall	lcd_write_data			; Daten
		ldi		TEMP_A,GFXHOME
		rcall	lcd_write_cmd			; Kommando

		ldi		TEMP_A,SPALTEN			; Text Area
		rcall	lcd_write_data			; Daten
		clr		TEMP_A
		rcall	lcd_write_data			; Daten
		ldi		TEMP_A,TXTAREA
		rcall	lcd_write_cmd			; Kommando

		ldi		TEMP_A,SPALTEN			; Grafik Area
		rcall	lcd_write_data			; Daten
		clr		TEMP_A
		rcall	lcd_write_data			; Daten
		ldi		TEMP_A,GFXAREA
		rcall	lcd_write_cmd			; Kommando

		ldi		TEMP_A,MODE				; Display Mode OR, Interner CharGen
		rcall	lcd_write_cmd			; Kommando

		ldi		TEMP_A,low(CHR_OFFSET)			; Offset-Adresse CharGen
		rcall	lcd_write_data			; Daten
		ldi		TEMP_A,high(CHR_OFFSET)
		rcall	lcd_write_data			; Daten
		ldi		TEMP_A,OFFSETA
		rcall	lcd_write_cmd			; Kommando

		ldi		TEMP_A,D_MODE+D_MODE_TXT_GFX	; Text ON, Grafik ON, Cursor OFF, Blink OFF
		rcall	lcd_write_cmd			; Kommando

		rcall	lcd_write_chargen
		rcall	lcd_clr_txt
  		rcall	lcd_clr_gfx

		ret

;***************************************************************************
;  Sendet Kommando zum Display
;  Daten in TEMP_A	
;  Scratch-Reg: -
;***************************************************************************
lcd_write_auto:
		rcall	lcd_status_w_auto
		rjmp	lcd_data

;***************************************************************************
;  Sendet Kommando zum Display
;  Daten in TEMP_A	
;  Scratch-Reg: -
;***************************************************************************
lcd_write_cmd:
		rcall	lcd_status
		rjmp	lcd_write

;***************************************************************************
;  Sendet Daten zum Display
;  Daten in TEMP_A	
;  Scratch-Reg: -
;***************************************************************************
lcd_write_data:
		rcall	lcd_status

lcd_data:
		cbi		LCD_C_PORT,LCD_CD			; Daten

lcd_write:
		out		LCD_D_OUT,TEMP_A			; Daten raus

		cbi		LCD_C_PORT,LCD_CE			; Enable L
		cbi		LCD_C_PORT,LCD_WR			; Write L

		sbi		LCD_C_PORT,LCD_WR			; Write H
		sbi		LCD_C_PORT,LCD_CE			; Enable H

		sbi		LCD_C_PORT,LCD_CD			; Kommando

		ret

;***************************************************************************
;  Liest Status vom Display
;  	
;  Scratch-Reg: -
;***************************************************************************
lcd_status:
		push	TEMP_A

		clr		TEMP_A
		out		LCD_D_DIR,TEMP_A		; auf Eingang

		cbi		LCD_C_PORT,LCD_CE		; Enable L

lcd_status_loop:
		cbi		LCD_C_PORT,LCD_RD		; Read L
		in		TEMP_A,LCD_D_IN			; Daten lesen
		sbi		LCD_C_PORT,LCD_RD		; Read H
		
		andi	TEMP_A,(1<<STAT_CMD)+(1<<STAT_RW)		; STA0 und STA1
		cpi		TEMP_A,(1<<STAT_CMD)+(1<<STAT_RW)
		brne	lcd_status_loop			; weiter warten

		sbi		LCD_C_PORT,LCD_CE		; Enable H

		ser		TEMP_A
		out		LCD_D_DIR,TEMP_A		; Daten auf Ausgang

		pop		TEMP_A
		ret

;***************************************************************************
;  Liest Auto-Status vom Display
;  	
;  Scratch-Reg: -
;***************************************************************************
lcd_status_w_auto:
		push	TEMP_A

		clr		TEMP_A
		out		LCD_D_DIR,TEMP_A		; auf Eingang

		cbi		LCD_C_PORT,LCD_CE		; Enable L

lcd_status_w_auto_loop:
		cbi		LCD_C_PORT,LCD_RD		; Read L
		in		TEMP_A,LCD_D_IN			; Daten lesen
		sbi		LCD_C_PORT,LCD_RD		; Read H

		andi	TEMP_A,(1<<STAT_W_AUTO)	; STA3
		cpi		TEMP_A,(1<<STAT_W_AUTO)
		brne	lcd_status_w_auto_loop	; weiter warten

		sbi		LCD_C_PORT,LCD_CD		; Enable H

		ser		TEMP_A
		out		LCD_D_DIR,TEMP_A		; Daten auf Ausgang

		pop	TEMP_A
		ret

;***************************************************************************
;  Schreibt Char-Daten in Display-Char-Ram
;  	
;  Scratch-Reg: TEMP_A, TEMP_B, Z
;***************************************************************************
lcd_write_chargen:
		load_p	Z,(2*charset)
		ldi		TEMP_A,low(CHR_BASE)		; Char-Adresse
		rcall	lcd_write_data
		ldi		TEMP_A,high(CHR_BASE)
		rcall	lcd_write_data
		ldi		TEMP_A,ADPSET
		rcall	lcd_write_cmd

		ldi		TEMP_A,AWRON
		rcall	lcd_write_cmd
		ldi		TEMP_B,CHR_ANZ*8				; 4x8Byte

lcd_write_chargen_loop:
		lpm		TEMP_A,Z+
		rcall	lcd_write_auto
		dec		TEMP_B
		brne	lcd_write_chargen_loop

		ldi		TEMP_A,AWROFF
		rcall	lcd_write_cmd

		ret

;***************************************************************************
;  Lscht Textbereich vom Display
;  	
;  Scratch-Reg: -
;***************************************************************************
lcd_clr_txt:
		push	TEMP_A
		push	ZH
		push	ZL

		load_p	Z,TXT_ZEILEN*SPALTEN				; Spalten x Zeilen
		ldi		TEMP_A,low(TXT_BASE)
		rcall	lcd_write_data
		ldi		TEMP_A,high(TXT_BASE)
		rjmp	lcd_clr

;***************************************************************************
;  Lscht Grafikbereich vom Display
;  	
;  Scratch-Reg: TEMP_A, Z
;***************************************************************************
lcd_clr_gfx:
		push	TEMP_A
		push	ZH
		push	ZL

		load_p	Z,GFX_ZEILEN*SPALTEN				; Spalten x Zeilen

		ldi		TEMP_A,low(GFX_BASE)
		rcall	lcd_write_data
		ldi		TEMP_A,high(GFX_BASE)

lcd_clr:
  		rcall	lcd_write_data
  		ldi		TEMP_A,ADPSET
		rcall	lcd_write_cmd
		ldi		TEMP_A,AWRON
		rcall	lcd_write_cmd

lcd_clr_gfx_loop:
		clr		TEMP_A
		rcall	lcd_write_auto
		subi	ZL,1
		sbci	ZH,0
		brcc	lcd_clr_gfx_loop

		ldi		TEMP_A,AWROFF
 		rcall	lcd_write_cmd 
	
		pop		ZL
		pop		ZH
		pop		TEMP_A		
		ret

;***************************************************************************
;  Schreibt Text aus Rom ins Display
;  Textzeile in YH, Textspalte in YL, Textadresse in Z	
;  Scratch-Reg: -
;***************************************************************************
lcd_write_rom_txt:
		rcall	lcd_col_row2adr
		mov		TEMP_A,YL
		rcall	lcd_write_data
		mov		TEMP_A,YH
		rcall	lcd_write_data
		ldi		TEMP_A,ADPSET
		rcall	lcd_write_cmd

		ldi		TEMP_A,AWRON
		rcall	lcd_write_cmd

lcd_write_rom_txt_loop:
		lpm		TEMP_A,Z+
		tst		TEMP_A							; 0-Byte?
		breq	lcd_write_rom_txt_end

		subi	TEMP_A,$20
		rcall	lcd_write_auto
		rjmp	lcd_write_rom_txt_loop

lcd_write_rom_txt_end:
		ldi		TEMP_A,AWROFF
		rcall	lcd_write_cmd

		ret

;***************************************************************************
;  Schreibt dn Inhalt einer Ram-Tabelle in den Grafikbereich vom Display
;	
;  Scratch-Reg: -
;***************************************************************************
lcd_write_table:
		push	TEMP_A
		push	TEMP_B
		push	ZH
		push	ZL
		push	YH
		push	YL
		push	XL

		load_p	Y,TABELLE				; wegen adiw am Schleifenanfang
		clr		TEMP_B					; Spaltenzhler
		ldi		XL,FONT_SIZE-1			; Bitzhler, LSB mu nach links

lcd_write_table_loop_0:
		load_p	Z,GFX_BASE				; Start Grafik
		ld		TEMP_A,Y+				; Wert holen -> Zeilennummer

		push	TEMP_B
		ldi		TEMP_B,127				; maximum
		sub		TEMP_B,TEMP_A
		mov		TEMP_A,TEMP_B			; 0 nach unten!
		pop		TEMP_B

		tst		TEMP_A					; Zeile 0 ?
		breq	lcd_write_table_line_0	; ja

lcd_write_table_loop_1:					; solange Addieren, bis Zeilenadresse erreicht			
		adiw	Z,SPALTEN
		dec		TEMP_A
		brne	lcd_write_table_loop_1
					
lcd_write_table_line_0:
		add		ZL,TEMP_B				; aktuelle Spalte dazu
		clr		TEMP_A
		adc		ZH,TEMP_A

		mov		TEMP_A,XL				; Bitnummer

		rcall	lcd_set_pixel

		subi	XL,1					; Bitzhler
		brcc	lcd_write_table_loop_0

		ldi		XL,FONT_SIZE-1
		inc		TEMP_B
		cpi		TEMP_B,SPALTEN
		brne	lcd_write_table_loop_0

		pop		XL
		pop		YL				
		pop		YH
		pop		ZL
		pop		ZH
		pop		TEMP_B
		pop		TEMP_A
		ret

;***************************************************************************
;  Zeichnet eine senkrechte Linie ab Adresse im Grafikbereich vom Display
;  Spaltennummer in TEMP_A	
;  Scratch-Reg: -
;***************************************************************************
lcd_vert_line:
		push	TEMP_B
		push	ZH
		push	ZL

		load_p	Z,GFX_BASE
		ldi		TEMP_B,$FF				; Korrektur Spaltenzhler wegen inc am Anfang der Schleife


lcd_vert_line_spalte:
		inc		TEMP_B					; Anzahl Spalte +1
		subi	TEMP_A,FONT_SIZE				; Anzahl Pixel
		brcc	lcd_vert_line_spalte	; nicht unter 0
			
		add		ZL,TEMP_B				; Spalte dazu
		clr		TEMP_B					; 0
		adc		ZH,TEMP_B

		subi	TEMP_A,-FONT_SIZE		; Pixelnummer berechnen

		ldi		TEMP_B,FONT_SIZE-1		; LSB mu nach links
		sub		TEMP_B,TEMP_A
		mov		TEMP_A,TEMP_B

		ldi		TEMP_B,GFX_ZEILEN		; Anzahl Zeilen

lcd_vert_line_loop_0:
		push	TEMP_A
		rcall	lcd_set_pixel
		pop		TEMP_A

		adiw	Z,SPALTEN
		dec		TEMP_B
		brne	lcd_vert_line_loop_0

		pop		ZL
		pop		ZH
		pop		TEMP_B
		ret

;***************************************************************************
;  Zeichnet eine waagerechte Linie ab Adresse im Grafikbereich vom Display
;  Zeilennummer in TEMP_A	
;  Scratch-Reg: -
;***************************************************************************
lcd_hor_line:
		push	TEMP_B
		push	ZH
		push	ZL

		load_p	Z,GFX_BASE
		tst		TEMP_A					; Zeile = 0 ?
		breq	lcd_hpr_line_0

lcd_hor_line_loop_0:
		adiw	Z,SPALTEN
		dec		TEMP_A
		brne	lcd_hor_line_loop_0

lcd_hpr_line_0:
		ldi		TEMP_B,SPALTEN
		mov		TEMP_A,ZL
		rcall	lcd_write_data
		mov		TEMP_A,ZH
		rcall	lcd_write_data
		ldi		TEMP_A,ADPSET
		rcall	lcd_write_cmd			; Zeiger auf Zeilenanfang

		ldi		TEMP_A,AWRON
		rcall	lcd_write_cmd			; Automatik ein

lcd_hor_line_loop_1:
		ldi		TEMP_A,0b11111111		; immer mit 8 Pixel Breite laden
		rcall	lcd_write_auto
		dec		TEMP_B
		brne	lcd_hor_line_loop_1

		ldi		TEMP_A,AWROFF
		rcall	lcd_write_cmd			; Automatik aus

		pop		ZL
		pop		ZH
		pop		TEMP_B
		ret

;***************************************************************************
;  Setzt Pixel im Grafikbereich vom Display
;  Adresse in Z, Bitnummer in TEMP_A	
;  Scratch-Reg: -
;***************************************************************************
lcd_set_pixel:
		push	TEMP_B

		ldi		TEMP_B,BITSET
		or		TEMP_A,TEMP_B
		push	TEMP_A

		mov		TEMP_A,ZL
		rcall	lcd_write_data
		mov		TEMP_A,ZH
		rcall	lcd_write_data
		ldi		TEMP_A,ADPSET
		rcall	lcd_write_cmd

		pop		TEMP_A
		rcall	lcd_write_cmd

		pop		TEMP_B
		ret

;***************************************************************************
;  Berechnet Adresse aus Zeile + Spalte
;  Textzeile in YH, Textspalte in YL	
;  Scratch-Reg: -
;***************************************************************************
lcd_col_row2adr:
		push	ZH
		push	ZL	

		load_p	Z,TXT_BASE
		tst		YH							; Zeile 0 ?
		breq	lcd_col_row2adr_line_0
		
lcd_col_row2adr_loop:
		adiw	Z,SPALTEN
		dec		YH							; Zeile				
		brne	lcd_col_row2adr_loop		; Start Zeile berechnen

lcd_col_row2adr_line_0:
		add		YL,ZL
		adc		YH,ZH						; ist 0						

		pop		ZL
		pop		ZH
		ret

;*********************************************************************
;  Warte 5ms
;
;  Scratch-Reg: -
;*********************************************************************

wait_5ms:
        push    ZL
        push    ZH

        load_p  Z,5000*(CYCLES_PER_US/4)
		        ; 5 mS warten, 4 = Anzahl Befehls-Zyclen vom sbiw + brcc

d_loop:
        sbiw    ZL,1
        brne    d_loop

        pop     ZH
        pop     ZL

        ret

;***************************************************************************
;  Programm Ende 
;***************************************************************************
								 
text_1:
		.db		"Das ist ein Testtext",0

text_2:			; Achtung! Es werden $20 abgezogen vor der Ausgabe
		.db		$A0,' ',$A1,' ',$A2,' ',$A3,' '
		.db		$A4,' ',$A5,' ',$A6,' ',$A7,' '
		.db		$A8,' ',$A9,' ',$AA,0

charset:
		.db		0b10000000,0b10000000	;$80 -> $A0
		.db		0b10000000,0b10000000
		.db		0b10000000,0b11111111
		.db		0b10000000,0b10000000

		.db		0b01000000,0b01000000	;$81 -> $A1
		.db		0b01000000,0b01000000
		.db		0b01000000,0b11111111
		.db		0b01000000,0b01000000

		.db		0b00100000,0b00100000	;$82 -> $A2
		.db		0b00100000,0b00100000
		.db		0b00100000,0b11111111
		.db		0b00100000,0b00100000

		.db		0b00010000,0b00010000	;$83 -> $A3
		.db		0b00010000,0b00010000
		.db		0b00010000,0b11111111
		.db		0b00010000,0b00010000

		.db		0b00001000,0b00001000	;$84 -> $A4
		.db		0b00001000,0b00001000
		.db		0b00001000,0b11111111
		.db		0b00001000,0b00001000

		.db		0b00000100,0b00000100	;$85 -> $A5
		.db		0b00000100,0b00000100
		.db		0b00000100,0b11111111
		.db		0b00000100,0b00000100

		.db		0b00000010,0b00000010	;$86 -> $A6
		.db		0b00000010,0b00000010
		.db		0b00000010,0b11111111
		.db		0b00000010,0b00000010

		.db		0b00000001,0b00000001	;$87 -> $A7
		.db		0b00000001,0b00000001
		.db		0b00000001,0b11111111
		.db		0b00000001,0b00000001

		.db		0b00001000,0b00001000	;$88 -> $A8
		.db		0b00001000,0b00001000
		.db		0b00001000,0b11111111
		.db		0b00001000,0b00001000

		.db		0b00000000,0b00000000	;$89 -> $A9
		.db		0b00000000,0b00000000
		.db		0b00000000,0b11111111
		.db		0b00000000,0b00000000

		.db		0b00001000,0b00001000	;$8A -> $AA
		.db		0b00001000,0b00001000
		.db		0b00001000,0b00001000
		.db		0b00001000,0b00001000

sinus:
		.db 	64,65,67,68,70,72,73,75 
		.db 	76,78,79,81,82,84,85,87 
		.db 	88,90,91,92,94,95,97,98 
		.db 	99,100,102,103,104,105,107,108 
		.db 	109,110,111,112,113,114,115,116 
		.db 	117,118,118,119,120,121,121,122 
		.db 	123,123,124,124,125,125,126,126 
		.db 	126,127,127,127,127,127,127,127 
		.db 	127,127,127,127,127,127,127,127 
		.db 	126,126,126,125,125,124,124,123 
		.db 	123,122,121,121,120,119,118,118 
		.db 	117,116,115,114,113,112,111,110 
		.db 	109,108,107,105,104,103,102,100 
		.db 	99,98,97,95,94,92,91,90 
		.db 	88,87,85,84,82,81,79,78 
		.db 	76,75,73,72,70,68,67,65 
		.db 	64,62,61,59,58,56,54,53 
		.db	 	51,50,48,47,45,44,42,41 
		.db 	39,38,36,35,34,32,31,30 
		.db 	28,27,26,25,23,22,21,20 
		.db 	19,18,17,15,14,13,13,12 
		.db 	11,10,9,8,8,7,6,5 
		.db 	5,4,4,3,3,2,2,2 
		.db 	1,1,1,0,0,0,0,0 
		.db 	0,0,0,0,0,0,1,1 
		.db 	1,2,2,2,3,3,4,4 
		.db 	5,5,6,7,8,8,9,10 
		.db 	11,12,13,13,14,15,17,18 
		.db 	19,20,21,22,23,25,26,27 
		.db 	28,30,31,32,34,35,36,38 
		.db 	39,41,42,44,45,47,48,50 
		.db 	51,53,54,56,58,59,61,62 
